import { Module } from '@nestjs/common';
import { AppController } from './app.controller';
import { AppService } from './app.service';

import { AppAuthModule } from './modules/auth/auth.module';
import { AppClsModule } from './modules/cls/cls.module';
import { AppConfigModule } from './modules/config/config.module';
import { AppDatabaseModule } from './modules/database/database.module';
import { EnumifyModule } from './modules/enumify/enumify.module';
import { AppFileTransactionsModule } from './modules/file-transactions/file-transactions.module';
import { AppHealthModule } from './modules/health/health.module';
import { AppLoggerModule } from './modules/logger/logger.module';
import { AppRequestLoggingModule } from './modules/request-logging/request-logging.module';
import { AppScheduleModule } from './modules/schedule/schedule.module';
import { AppValidationModule } from './modules/validation/validation.module';

import { AnagraficaModule } from './features/anagrafica/anagrafica.module';

@Module({
  imports: [
    AppConfigModule,
    AppLoggerModule,
    AppDatabaseModule,
    AppClsModule,
    AppHealthModule,
    AppFileTransactionsModule,
    AppScheduleModule,
    AppValidationModule,
    AppAuthModule,
    AppRequestLoggingModule,
    EnumifyModule,
    AnagraficaModule,
  ],
  controllers: [AppController],
  providers: [AppService],
})
export class AppModule {}
