import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { SocioEntity } from '../../modules/database/connections/oceano';
import { OCEANO_DATASOURCE } from '../../modules/database/connections/oceano/database.constants';
import { AnagraficaController } from './anagrafica.controller';
import { AnagraficaService } from './anagrafica.service';

@Module({
  imports: [TypeOrmModule.forFeature([SocioEntity], OCEANO_DATASOURCE)],
  controllers: [AnagraficaController],
  providers: [AnagraficaService],
  exports: [AnagraficaService],
})
export class AnagraficaModule {}
