import { Column, Entity, Index, OneToMany, PrimaryGeneratedColumn } from 'typeorm';
import { ApiClientInvocazioniEntity } from './api_client_invocazioni.entity';

@Index('pk_api_client', ['id'], { unique: true })
@Entity('api_client')
export class ApiClientEntity {
  @PrimaryGeneratedColumn({ type: 'int', name: 'id' })
  id!: number;

  @Column('varchar', { name: 'nome', nullable: true, length: 255 })
  nome!: string | null;

  @Column('varchar', { name: 'descrizione', nullable: true, length: 255 })
  descrizione!: string | null;

  @Column('varchar', { name: 'base_url', length: 2000 })
  baseUrl!: string;

  @OneToMany(() => ApiClientInvocazioniEntity, (apiClientInvocazioniEntity) => apiClientInvocazioniEntity.client)
  invocazioni!: ApiClientInvocazioniEntity[];

  constructor(init?: Partial<ApiClientEntity>) {
    Object.assign(this, init);
  }
}
