import { Column, Entity, Index, JoinColumn, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { ApiClientEntity } from './api_client.entity';

@Index('pk_api_client_invocazioni', ['id'], { unique: true })
@Entity('api_client_invocazioni')
export class ApiClientInvocazioniEntity {
  @PrimaryGeneratedColumn({ type: 'int', name: 'id' })
  id!: number;

  @Column('int', { name: 'id_client' })
  idClient!: number;

  @Column('varchar', { name: 'percorso', length: 2000 })
  percorso!: string;

  @Column('varchar', { name: 'metodo', length: 7 })
  metodo!: string;

  @Column('datetime', { name: 'timestamp' })
  timestamp!: Date;

  @Column('varchar', { name: 'richiesta', nullable: true })
  richiesta!: string | null;

  @Column('varchar', { name: 'risposta' })
  risposta!: string;

  @Column('varchar', { name: 'errori', nullable: true })
  errori!: string | null;

  @Column('bit', { name: 'flag_errore' })
  flagErrore!: boolean;

  @ManyToOne(() => ApiClientEntity, (apiClientEntity) => apiClientEntity.invocazioni)
  @JoinColumn([{ name: 'id_client', referencedColumnName: 'id' }])
  client!: ApiClientEntity;

  constructor(init?: Partial<ApiClientInvocazioniEntity>) {
    Object.assign(this, init);
  }
}
