import { Column, Entity, Index, OneToMany, PrimaryGeneratedColumn } from 'typeorm';
import { ApiEndpointInvocazioniEntity } from './api_endpoint_invocazioni.entity';

@Index('pk_api_endpoint', ['id'], { unique: true })
@Entity('api_endpoint')
export class ApiEndpointEntity {
  @PrimaryGeneratedColumn({ type: 'int', name: 'id' })
  id!: number;

  @Column('varchar', { name: 'percorso', length: 2000 })
  percorso!: string;

  @Column('varchar', { name: 'metodo', length: 7 })
  metodo!: string;

  @OneToMany(
    () => ApiEndpointInvocazioniEntity,
    (apiEndpointInvocazioniEntity) => apiEndpointInvocazioniEntity.endpoint,
  )
  invocazioni!: ApiEndpointInvocazioniEntity[];

  constructor(init?: Partial<ApiEndpointEntity>) {
    Object.assign(this, init);
  }
}
