import { Column, Entity, Index } from 'typeorm';
import { Enum, Enumify } from '../../../../enumify/enumify';

export class InviaMailSeErrori {
  @Column('bit', { name: 'flag', default: () => '(0)' })
  flagAttivo!: boolean;

  @Column('varchar', { name: 'oggetto', nullable: true, length: 255 })
  oggetto!: string | null;

  @Column('varchar', { name: 'destinatari', nullable: true, length: 255 })
  destinatari!: string | null;

  @Column('varchar', { name: 'cc', nullable: true, length: 255 })
  cc!: string | null;
}

@Index('pk_tipi_jobs', ['id'], { unique: true })
@Entity('tipi_jobs')
export class TipiJobsEntity extends Enumify {
  static _ = TipiJobsEntity.closeEnum();

  @Column('int', { primary: true, name: 'id' })
  declare id: number;

  @Column('varchar', { name: 'nome', length: 50 })
  declare nome: string;

  @Column('varchar', { name: 'descrizione', nullable: true, length: 255 })
  descrizione!: string | null;

  @Column(() => InviaMailSeErrori, { prefix: 'invia_mail_se_errori' })
  inviaMailSeErrori!: InviaMailSeErrori;

  @Column('bit', { name: 'flag_attivo', default: () => '(0)' })
  flagAttivo!: boolean;

  @Column('varchar', { name: 'pattern_cron', length: 20 })
  patternCron!: string;

  public constructor(id: number, nome: string, patternCron: string) {
    super(id, nome);
    this.patternCron = patternCron;
  }
}
