import { Column, Entity, Index, JoinColumn, ManyToOne } from 'typeorm';
import { ApiLuoghiEntity } from './API_Luoghi.entity';

@Index('nk_API_CAP_Luoghi', ['codice', 'cap'], { unique: true })
@Entity('API_CAP_Luoghi')
export class ApiCapLuoghiEntity {
  @Column('varchar', { primary: true, name: 'codice', length: 5 })
  codice!: string;

  @Column('varchar', { primary: true, name: 'cap', length: 5 })
  cap!: string;

  @ManyToOne(() => ApiLuoghiEntity)
  @JoinColumn([{ name: 'codice', referencedColumnName: 'codice' }])
  luogo!: ApiLuoghiEntity;

  constructor(init?: Partial<ApiCapLuoghiEntity>) {
    Object.assign(this, init);
  }
}
