import { Column, Entity, Index, OneToMany } from 'typeorm';
import { ApiCapLuoghiEntity } from './API_CAP_Luoghi.entity';
import { SocioEntity } from './socio.entity';

@Index('PK_API_Luoghi', ['codice'], { unique: true })
@Entity('API_Luoghi')
export class ApiLuoghiEntity {
  @Column('varchar', { primary: true, name: 'codice', length: 5 })
  codice!: string;

  @Column('nvarchar', { name: 'comune', nullable: true, length: 255 })
  comune!: string | null;

  @Column('nvarchar', { name: 'sigla_provincia', nullable: true, length: 5 })
  siglaProvincia!: string | null;

  @Column('nvarchar', { name: 'provincia', nullable: true, length: 255 })
  provincia!: string | null;

  @Column('nvarchar', { name: 'codice_regione', nullable: true, length: 5 })
  codiceRegione!: string | null;

  @Column('nvarchar', { name: 'regione', nullable: true, length: 255 })
  regione!: string | null;

  @Column('nvarchar', { name: 'codice_stato', nullable: true, length: 5 })
  codiceStato!: string | null;

  @Column('nvarchar', { name: 'stato', nullable: true, length: 255 })
  stato!: string | null;

  @Column('int', { name: 'flag_attivo', nullable: true })
  flagAttivo!: number | null;

  constructor(init?: Partial<ApiLuoghiEntity>) {
    Object.assign(this, init);
  }
}
