import { Column, Entity, Index, JoinColumn, ManyToOne } from 'typeorm';

@Index('PK_allegati', ['codiceAllegato'], { unique: true })
@Entity('allegati')
export class AllegatiEntity {
  @Column('bigint', { primary: true, name: 'codiceAllegato' })
  codiceAllegato!: string;

  @Column('int', { name: 'tipoOrigine', nullable: true })
  tipoOrigine!: number | null;

  @Column('bigint', { name: 'codiceOrigine', nullable: true })
  codiceOrigine!: string | null;

  @Column('nvarchar', {
    name: 'descrizioneAllegato',
    nullable: true,
    length: 255,
  })
  descrizioneAllegato!: string | null;

  @Column('nvarchar', { name: 'dataAllegato', nullable: true, length: 10 })
  dataAllegato!: string | null;

  @Column('nvarchar', {
    name: 'cartellaAllegato',
    nullable: true,
    length: 2048,
  })
  cartellaAllegato!: string | null;

  @Column('nvarchar', { name: 'nomeFileAllegato', nullable: true, length: 255 })
  nomeFileAllegato!: string | null;

  @Column('ntext', { name: 'noteAllegato', nullable: true })
  noteAllegato!: string | null;

  @Column('bigint', { name: 'utenteCreazione', nullable: true })
  utenteCreazione!: string | null;

  @Column('nvarchar', { name: 'dataCreazione', nullable: true, length: 10 })
  dataCreazione!: string | null;

  @Column('nvarchar', { name: 'oraCreazione', nullable: true, length: 8 })
  oraCreazione!: string | null;

  @Column('bigint', { name: 'utenteModifica', nullable: true })
  utenteModifica!: string | null;

  @Column('nvarchar', { name: 'dataModifica', nullable: true, length: 10 })
  dataModifica!: string | null;

  @Column('nvarchar', { name: 'oraModifica', nullable: true, length: 8 })
  oraModifica!: string | null;

  @Column('int', { name: 'pubblicatoWEB', nullable: true })
  pubblicatoWeb!: number | null;

  @Column('int', {
    name: 'trasferitoWEB',
    nullable: true,
    default: () => '(0)',
  })
  trasferitoWeb!: number | null;

  @Column('nvarchar', {
    name: 'dataPubblicazione',
    nullable: true,
    length: 10,
    default: () => "''",
  })
  dataPubblicazione!: string | null;

  @Column('bigint', {
    name: 'codiceProtocolloGenerico',
    nullable: true,
    default: () => '(0)',
  })
  codiceProtocolloGenerico!: string | null;

  constructor(init?: Partial<AllegatiEntity>) {
    Object.assign(this, init);
  }
}
