import { Column, Entity, Index, JoinColumn, ManyToOne, OneToMany } from 'typeorm';
import { EnteEntity } from './ente.entity';
import { SocioContrattoEntity } from './socioContratto.entity';

@Index('PK_contratto', ['codiceContratto'], { unique: true })
@Entity('contratto')
export class ContrattoEntity {
  @Column('bigint', { primary: true, name: 'codiceContratto' })
  codiceContratto!: string;

  @Column('bigint', { name: 'codiceEnte', nullable: true })
  codiceEnte!: string | null;

  @Column('nvarchar', { name: 'contratto', nullable: true, length: 255 })
  contratto!: string | null;

  @Column('nvarchar', { name: 'dataContratto', nullable: true, length: 10 })
  dataContratto!: string | null;

  @Column('int', { name: 'rinnovoAutomatico', nullable: true })
  rinnovoAutomatico!: number | null;

  @Column('nvarchar', {
    name: 'dataDecorrenzaContratto',
    nullable: true,
    length: 10,
  })
  dataDecorrenzaContratto!: string | null;

  @Column('nvarchar', {
    name: 'codiceEconomicoEsolver',
    nullable: true,
    length: 30,
  })
  codiceEconomicoEsolver!: string | null;

  @Column('nvarchar', {
    name: 'codicePatrimonialeEsolver',
    nullable: true,
    length: 30,
  })
  codicePatrimonialeEsolver!: string | null;

  @Column('int', { name: 'iscrizioneFamiliariObbligatoria', nullable: true })
  iscrizioneFamiliariObbligatoria!: number | null;

  @Column('int', {
    name: 'inizioDecorrenzaNuoveAdesioniAderenti',
    nullable: true,
  })
  inizioDecorrenzaNuoveAdesioniAderenti!: number | null;

  @Column('int', {
    name: 'inizioDecorrenzaNuoveAdesioniFamiliari',
    nullable: true,
  })
  inizioDecorrenzaNuoveAdesioniFamiliari!: number | null;

  @Column('int', { name: 'cessazioneInfraAnnuale', nullable: true })
  cessazioneInfraAnnuale!: number | null;

  @Column('int', { name: 'numeroGiorniRimborso', nullable: true })
  numeroGiorniRimborso!: number | null;

  @Column('int', { name: 'rimborsoPersona', nullable: true })
  rimborsoPersona!: number | null;

  @Column('int', { name: 'rimborsoFax', nullable: true })
  rimborsoFax!: number | null;

  @Column('int', { name: 'rimborsoEmail', nullable: true })
  rimborsoEmail!: number | null;

  @Column('int', { name: 'rimborsoPosta', nullable: true })
  rimborsoPosta!: number | null;

  @Column('int', { name: 'rimborsoWeb', nullable: true })
  rimborsoWeb!: number | null;

  @Column('bigint', { name: 'utentecreazione', nullable: true })
  utentecreazione!: string | null;

  @Column('nvarchar', { name: 'dataCreazione', nullable: true, length: 10 })
  dataCreazione!: string | null;

  @Column('nvarchar', { name: 'oraCreazione', nullable: true, length: 8 })
  oraCreazione!: string | null;

  @Column('bigint', { name: 'utenteModifica', nullable: true })
  utenteModifica!: string | null;

  @Column('nvarchar', { name: 'dataModifica', nullable: true, length: 10 })
  dataModifica!: string | null;

  @Column('nvarchar', { name: 'oraModifica', nullable: true, length: 8 })
  oraModifica!: string | null;

  @Column('ntext', { name: 'noteContratto', nullable: true })
  noteContratto!: string | null;

  @Column('int', { name: 'versamentiTerzi', nullable: true })
  versamentiTerzi!: number | null;

  @Column('int', { name: 'ignoraControlloPagamenti', nullable: true })
  ignoraControlloPagamenti!: number | null;

  @Column('int', { name: 'anniRinnovo', nullable: true })
  anniRinnovo!: number | null;

  @Column('bigint', { name: 'codiceRivenditore', nullable: true })
  codiceRivenditore!: string | null;

  @Column('int', {
    name: 'inizioDecorrenzaNuoveAdesioniNascita',
    nullable: true,
  })
  inizioDecorrenzaNuoveAdesioniNascita!: number | null;

  @Column('int', { name: 'numeroGiorniNascita', nullable: true })
  numeroGiorniNascita!: number | null;

  @Column('int', { name: 'mesiEsclusionePatologieAderenti', nullable: true })
  mesiEsclusionePatologieAderenti!: number | null;

  @Column('int', { name: 'mesiEsclusionePatologieFamiliari', nullable: true })
  mesiEsclusionePatologieFamiliari!: number | null;

  @Column('int', { name: 'coperturaPreesistenzeAderenti', nullable: true })
  coperturaPreesistenzeAderenti!: number | null;

  @Column('int', { name: 'coperturaPreesistenzeFamiliari', nullable: true })
  coperturaPreesistenzeFamiliari!: number | null;

  @Column('int', { name: 'adesioniFdaIndividuali', nullable: true })
  adesioniFdaIndividuali!: number | null;

  @Column('nvarchar', {
    name: 'dataAssunzioneAderenti',
    nullable: true,
    length: 10,
  })
  dataAssunzioneAderenti!: string | null;

  @Column('int', { name: 'associazioniIndividuali', nullable: true })
  associazioniIndividuali!: number | null;

  @Column('bigint', { name: 'categoria', nullable: true })
  categoria!: string | null;

  @Column('nvarchar', { name: 'email', nullable: true, length: 80 })
  email!: string | null;

  @Column('nvarchar', { name: 'fax', nullable: true, length: 80 })
  fax!: string | null;

  @Column('nvarchar', { name: 'telefono', nullable: true, length: 80 })
  telefono!: string | null;

  @Column('nvarchar', { name: 'sitoWeb', nullable: true, length: 80 })
  sitoWeb!: string | null;

  @Column('nvarchar', { name: 'riferimento', nullable: true, length: 80 })
  riferimento!: string | null;

  @Column('int', { name: 'comunicazioniFax', nullable: true })
  comunicazioniFax!: number | null;

  @Column('int', { name: 'comunicazioniEmail', nullable: true })
  comunicazioniEmail!: number | null;

  @Column('int', { name: 'comunicazioniSito', nullable: true })
  comunicazioniSito!: number | null;

  @Column('int', { name: 'comunicazioniPosta', nullable: true })
  comunicazioniPosta!: number | null;

  @Column('int', { name: 'gestionePreventiviWEB', nullable: true })
  gestionePreventiviWeb!: number | null;

  @Column('nvarchar', {
    name: 'codiceDocumentoWEB',
    nullable: true,
    length: 80,
  })
  codiceDocumentoWeb!: string | null;

  @Column('int', { name: 'numeroGiorniEffettuareRimborsi', nullable: true })
  numeroGiorniEffettuareRimborsi!: number | null;

  @Column('int', { name: 'numeroGiorniIntegrazioneDocumenti', nullable: true })
  numeroGiorniIntegrazioneDocumenti!: number | null;

  @Column('int', { name: 'gestioneIndividuali', nullable: true })
  gestioneIndividuali!: number | null;

  @Column('int', { name: 'fondoPluriaziendale', nullable: true })
  fondoPluriaziendale!: number | null;

  @Column('nvarchar', { name: 'emailCertificata', nullable: true, length: 80 })
  emailCertificata!: string | null;

  @Column('int', { name: 'comunicazioniEmailCertificata', nullable: true })
  comunicazioniEmailCertificata!: number | null;

  @Column('nvarchar', {
    name: 'dataAssunzioneFamiliari',
    nullable: true,
    length: 10,
  })
  dataAssunzioneFamiliari!: string | null;

  @Column('int', {
    name: 'coperturaPreesistenzeAderentiNuoveAssunzioni',
    nullable: true,
  })
  coperturaPreesistenzeAderentiNuoveAssunzioni!: number | null;

  @Column('int', {
    name: 'coperturaPreesistenzeFamiliariNuoveAssunzioni',
    nullable: true,
  })
  coperturaPreesistenzeFamiliariNuoveAssunzioni!: number | null;

  @Column('int', { name: 'noCessazioneAutomaticaFineAnno', nullable: true })
  noCessazioneAutomaticaFineAnno!: number | null;

  @Column('int', { name: 'contrattoRateSemestrali', nullable: true })
  contrattoRateSemestrali!: number | null;

  @Column('decimal', {
    name: 'moraRitardoPagamenti',
    nullable: true,
    precision: 18,
    scale: 2,
  })
  moraRitardoPagamenti!: number | null;

  @Column('decimal', {
    name: 'quotaRichiestaFondo',
    nullable: true,
    precision: 18,
    scale: 2,
  })
  quotaRichiestaFondo!: number | null;

  @Column('int', { name: 'percQuotaRichiestaFondo', nullable: true })
  percQuotaRichiestaFondo!: number | null;

  @Column('int', { name: 'scontoIndividuali', nullable: true })
  scontoIndividuali!: number | null;

  @Column('int', {
    name: 'modalitaCalcoloDatiContributiviIndividuali',
    nullable: true,
  })
  modalitaCalcoloDatiContributiviIndividuali!: number | null;

  @Column('bigint', { name: 'codiceFiguraContratto', nullable: true })
  codiceFiguraContratto!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloTesserini',
    nullable: true,
    length: 255,
  })
  nomeModelloTesserini!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloLettera',
    nullable: true,
    length: 255,
  })
  nomeModelloLettera!: string | null;

  @Column('int', { name: 'ignoraControlloPagamentiTitolare', nullable: true })
  ignoraControlloPagamentiTitolare!: number | null;

  @Column('int', { name: 'ignoraControlloPagamentiAzienda', nullable: true })
  ignoraControlloPagamentiAzienda!: number | null;

  @Column('bigint', { name: 'codicePromoter', nullable: true })
  codicePromoter!: string | null;

  @Column('bigint', { name: 'codiceOriginePromoter', nullable: true })
  codiceOriginePromoter!: string | null;

  @Column('int', { name: 'fornituraTesserino', nullable: true })
  fornituraTesserino!: number | null;

  @Column('nvarchar', {
    name: 'dataChiusuraContratto',
    nullable: true,
    length: 10,
  })
  dataChiusuraContratto!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraRID',
    nullable: true,
    length: 255,
  })
  nomeModelloLetteraRid!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraAdesione',
    nullable: true,
    length: 255,
  })
  nomeModelloLetteraAdesione!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraAdeguamenti',
    nullable: true,
    length: 255,
  })
  nomeModelloLetteraAdeguamenti!: string | null;

  @Column('int', { name: 'coopersalute', nullable: true })
  coopersalute!: number | null;

  @Column('int', { name: 'forzaEstensioneTolleranza', nullable: true })
  forzaEstensioneTolleranza!: number | null;

  @Column('int', { name: 'giorniEstensioneTolleranza', nullable: true })
  giorniEstensioneTolleranza!: number | null;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraSollecito',
    nullable: true,
    length: 255,
  })
  nomeModelloLetteraSollecito!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraSollecito2',
    nullable: true,
    length: 255,
  })
  nomeModelloLetteraSollecito2!: string | null;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraNeonato',
    nullable: true,
    length: 255,
  })
  nomeModelloLetteraNeonato!: string | null;

  @Column('int', { name: 'comunicazioniViaEmail', nullable: true })
  comunicazioniViaEmail!: number | null;

  @Column('int', {
    name: 'modalitaCalcoloQuotaAssociativaFondo',
    default: () => '(0)',
  })
  modalitaCalcoloQuotaAssociativaFondo!: number;

  @Column('int', {
    name: 'modalitaCalcoloQuotaAssociativaNumeroFondo',
    default: () => '(0)',
  })
  modalitaCalcoloQuotaAssociativaNumeroFondo!: number;

  @Column('int', { name: 'quotaAssociativaFondo', default: () => '(0)' })
  quotaAssociativaFondo!: number;

  @Column('int', { name: 'tipoAnamnesi', default: () => '(1)' })
  tipoAnamnesi!: number;

  @Column('int', { name: 'primoCheck', default: () => '(1)' })
  primoCheck!: number;

  @Column('int', { name: 'secondoCheck', default: () => '(1)' })
  secondoCheck!: number;

  @Column('ntext', { name: 'testoPrimoCheck', default: () => "''" })
  testoPrimoCheck!: string;

  @Column('ntext', { name: 'testoSecondoCheck', default: () => "''" })
  testoSecondoCheck!: string;

  @Column('int', { name: 'calcolaQuotaWEB', default: () => '(1)' })
  calcolaQuotaWeb!: number;

  @Column('int', { name: 'verificaEsistenzaOnline', default: () => '(1)' })
  verificaEsistenzaOnline!: number;

  @Column('int', { name: 'titolareGiaAssociato', default: () => '(1)' })
  titolareGiaAssociato!: number;

  @Column('ntext', {
    name: 'intestazionePrimaPaginaAdesione',
    default: () => "''",
  })
  intestazionePrimaPaginaAdesione!: string;

  @Column('ntext', {
    name: 'intestazioneUltimaPaginaAdesione',
    default: () => "''",
  })
  intestazioneUltimaPaginaAdesione!: string;

  @Column('int', { name: 'importaComeAssociati', default: () => '(1)' })
  importaComeAssociati!: number;

  @Column('int', { name: 'importazioneAutomatica', default: () => '(1)' })
  importazioneAutomatica!: number;

  @Column('int', { name: 'stampaModuloAdesione', default: () => '(1)' })
  stampaModuloAdesione!: number;

  @Column('int', { name: 'terzoCheck', default: () => '(1)' })
  terzoCheck!: number;

  @Column('ntext', { name: 'testoTerzoCheck', default: () => "''" })
  testoTerzoCheck!: string;

  @Column('ntext', { name: 'testoEmailPreventivo', default: () => "''" })
  testoEmailPreventivo!: string;

  @Column('ntext', { name: 'testoEmailAdesione', default: () => "''" })
  testoEmailAdesione!: string;

  @Column('ntext', { name: 'oggettoEmailPreventivo', default: () => "''" })
  oggettoEmailPreventivo!: string;

  @Column('ntext', { name: 'oggettoEmailAdesione', default: () => "''" })
  oggettoEmailAdesione!: string;

  @Column('nvarchar', {
    name: 'nomeModelloLetteraStampaAdesione',
    length: 255,
    default: () => "''",
  })
  nomeModelloLetteraStampaAdesione!: string;

  @Column('ntext', {
    name: 'oggettoSecondaNotificaScadenzaPreventivo',
    default: () => "''",
  })
  oggettoSecondaNotificaScadenzaPreventivo!: string;

  @Column('ntext', {
    name: 'oggettoPrimaNotificaScadenzaPreventivo',
    default: () => "''",
  })
  oggettoPrimaNotificaScadenzaPreventivo!: string;

  @Column('ntext', {
    name: 'testoSecondaNotificaScadenzaPreventivo',
    default: () => "''",
  })
  testoSecondaNotificaScadenzaPreventivo!: string;

  @Column('ntext', {
    name: 'testoPrimaNotificaScadenzaPreventivo',
    default: () => "''",
  })
  testoPrimaNotificaScadenzaPreventivo!: string;

  @Column('bigint', { name: 'codiceBancaContributi', default: () => '(0)' })
  codiceBancaContributi!: string;

  @Column('bigint', { name: 'codiceBancaRimborsi', default: () => '(0)' })
  codiceBancaRimborsi!: string;

  @Column('ntext', {
    name: 'testataCertificazione',
    nullable: true,
    default: () => "''",
  })
  testataCertificazione!: string | null;

  @Column('ntext', { name: 'codaCertificazione', default: () => "''" })
  codaCertificazione!: string;

  @Column('ntext', { name: 'testataRiepilogoRimborsi', default: () => "''" })
  testataRiepilogoRimborsi!: string;

  @Column('int', { name: 'adesioneInfraAnnuale', default: () => '(0)' })
  adesioneInfraAnnuale!: number;

  @ManyToOne(() => EnteEntity, (enteEntity) => enteEntity.contratti)
  @JoinColumn([{ name: 'codiceEnte', referencedColumnName: 'codiceEnte' }])
  ente!: EnteEntity;

  @OneToMany(() => SocioContrattoEntity, (socioContrattoEntity) => socioContrattoEntity.contratto)
  socioContratto!: SocioContrattoEntity[];

  constructor(init?: Partial<ContrattoEntity>) {
    Object.assign(this, init);
  }
}
