import { Column, Entity, Index } from 'typeorm';

@Index(
  'PK_Missioni_Data',
  [
    'codiceFiscale',
    'tipoDocumento',
    'idMissione',
    'idLettera',
    'idPratica',
    'idAgenzia',
    'dataInizio',
    'dataFine',
    'tipoContratto',
  ],
  { unique: true },
)
@Entity('missioni')
export class MissioniEntity {
  @Column('nvarchar', { primary: true, name: 'codiceFiscale', length: 20 })
  codiceFiscale!: string;

  @Column('bigint', { primary: true, name: 'tipoDocumento' })
  tipoDocumento!: string;

  @Column('bigint', { primary: true, name: 'idMissione' })
  idMissione!: string;

  @Column('bigint', { primary: true, name: 'idLettera' })
  idLettera!: string;

  @Column('bigint', { primary: true, name: 'idPratica' })
  idPratica!: string;

  @Column('bigint', { primary: true, name: 'idAgenzia' })
  idAgenzia!: string;

  @Column('nvarchar', { primary: true, name: 'dataInizio', length: 10 })
  dataInizio!: string;

  @Column('nvarchar', { primary: true, name: 'dataFine', length: 10 })
  dataFine!: string;

  @Column('nvarchar', { primary: true, name: 'tipoContratto', length: 20 })
  tipoContratto!: string;

  @Column('bigint', { name: 'progressivoRecord', default: () => '(0)' })
  progressivoRecord!: string;

  constructor(init?: Partial<MissioniEntity>) {
    Object.assign(this, init);
  }
}
