import { Column, Entity, Index, JoinColumn, ManyToOne, OneToMany } from 'typeorm';
import { ApiLuoghiEntity } from './API_Luoghi.entity';
import { GruppoEntity } from './gruppo.entity';
import { SocioContrattoEntity } from './socioContratto.entity';
import { SocioFormeAssistenzaEntity } from './socioFormeAssistenza.entity';

@Index('PK_socio', ['codiceSocio'], { unique: true })
@Entity('socio')
export class SocioEntity {
  @Column('bigint', { name: 'codiceGruppo', nullable: true })
  codiceGruppo!: string | null;

  @Column('bigint', { primary: true, name: 'codiceSocio' })
  codiceSocio!: string;

  @Column('bigint', { name: 'matricolaSocio', nullable: true })
  matricolaSocio!: string | null;

  @Column('nvarchar', { name: 'cognome', nullable: true, length: 80 })
  cognome!: string | null;

  @Column('nvarchar', { name: 'nome', nullable: true, length: 80 })
  nome!: string | null;

  @Column('nvarchar', { name: 'dataNascita', nullable: true, length: 10 })
  dataNascita!: string | null;

  @Column('nvarchar', { name: 'codiceFiscale', nullable: true, length: 20 })
  codiceFiscale!: string | null;

  @Column('bigint', { name: 'codiceContrattoOld', nullable: true })
  codiceContrattoOld!: string | null;

  @Column('bigint', { name: 'socio.codiceFiguraContrattoOld', nullable: true })
  socioCodiceFiguraContrattoOld!: string | null;

  @Column('bigint', { name: 'codiceRivenditore', nullable: true })
  codiceRivenditore!: string | null;

  @Column('bigint', { name: 'utenteCreazione', nullable: true })
  utenteCreazione!: string | null;

  @Column('nvarchar', { name: 'dataCreazione', nullable: true, length: 10 })
  dataCreazione!: string | null;

  @Column('nvarchar', { name: 'oraCreazione', nullable: true, length: 8 })
  oraCreazione!: string | null;

  @Column('bigint', { name: 'utenteModifica', nullable: true })
  utenteModifica!: string | null;

  @Column('nvarchar', { name: 'dataModifica', nullable: true, length: 10 })
  dataModifica!: string | null;

  @Column('nvarchar', { name: 'oraModifica', nullable: true, length: 8 })
  oraModifica!: string | null;

  @Column('nvarchar', {
    name: 'residenzaIndirizzo',
    nullable: true,
    length: 80,
  })
  residenzaIndirizzo!: string | null;

  @Column('nvarchar', {
    name: 'residenzaNumeroCivico',
    nullable: true,
    length: 80,
  })
  residenzaNumeroCivico!: string | null;

  @Column('nvarchar', { name: 'residenzaLocalita', nullable: true, length: 80 })
  residenzaLocalita!: string | null;

  @Column('nvarchar', { name: 'residenzaCAP', nullable: true, length: 10 })
  residenzaCap!: string | null;

  @Column('bigint', { name: 'residenzaProvincia', nullable: true })
  residenzaProvincia!: string | null;

  @Column('bigint', { name: 'residenzaStato', nullable: true })
  residenzaStato!: string | null;

  @Column('nvarchar', {
    name: 'domicilioIndirizzo',
    nullable: true,
    length: 80,
  })
  domicilioIndirizzo!: string | null;

  @Column('nvarchar', {
    name: 'domicilioNumeroCivico',
    nullable: true,
    length: 80,
  })
  domicilioNumeroCivico!: string | null;

  @Column('nvarchar', { name: 'domicilioLocalita', nullable: true, length: 80 })
  domicilioLocalita!: string | null;

  @Column('nvarchar', { name: 'domicilioCAP', nullable: true, length: 10 })
  domicilioCap!: string | null;

  @Column('bigint', { name: 'domicilioProvincia', nullable: true })
  domicilioProvincia!: string | null;

  @Column('bigint', { name: 'domicilioStato', nullable: true })
  domicilioStato!: string | null;

  @Column('nvarchar', { name: 'nascitaLocalita', nullable: true, length: 80 })
  nascitaLocalita!: string | null;

  @Column('nvarchar', { name: 'nascitaCAP', nullable: true, length: 10 })
  nascitaCap!: string | null;

  @Column('bigint', { name: 'nascitaProvincia', nullable: true })
  nascitaProvincia!: string | null;

  @Column('bigint', { name: 'nascitaStato', nullable: true })
  nascitaStato!: string | null;

  @Column('nvarchar', { name: 'telefono', nullable: true, length: 80 })
  telefono!: string | null;

  @Column('nvarchar', { name: 'cellulare', nullable: true, length: 80 })
  cellulare!: string | null;

  @Column('nvarchar', { name: 'email', nullable: true, length: 80 })
  email!: string | null;

  @Column('bigint', { name: 'codiceSesso', nullable: true })
  codiceSesso!: string | null;

  @Column('bigint', { name: 'codiceStatoCivile', nullable: true })
  codiceStatoCivile!: string | null;

  @Column('bigint', { name: 'codiceProfessione', nullable: true })
  codiceProfessione!: string | null;

  @Column('int', { name: 'consensoComunicazioneDati', nullable: true })
  consensoComunicazioneDati!: number | null;

  @Column('int', { name: 'consensoDiffusioneDati', nullable: true })
  consensoDiffusioneDati!: number | null;

  @Column('int', { name: 'riassicurato', nullable: true })
  riassicurato!: number | null;

  @Column('nvarchar', { name: 'fax', nullable: true, length: 80 })
  fax!: string | null;

  @Column('nvarchar', { name: 'dataIscrizione', nullable: true, length: 10 })
  dataIscrizione!: string | null;

  @Column('nvarchar', {
    name: 'dataRichiestaRecesso',
    nullable: true,
    length: 10,
  })
  dataRichiestaRecesso!: string | null;

  @Column('nvarchar', { name: 'dataRecesso', nullable: true, length: 10 })
  dataRecesso!: string | null;

  @Column('int', { name: 'recessoAnnoSolareSuccessivo', nullable: true })
  recessoAnnoSolareSuccessivo!: number | null;

  @Column('int', { name: 'capofamiglia', nullable: true })
  flagCapofamiglia!: number | null;

  @Column('bigint', { name: 'livelloFamiliare', nullable: true })
  livelloFamiliare!: string | null;

  @Column('bigint', { name: 'codiceCapofamiglia', nullable: true })
  codiceCapofamiglia!: string | null;

  @Column('nvarchar', { name: 'codicePaese', nullable: true, length: 50 })
  codicePaese!: string | null;

  @Column('nvarchar', { name: 'codiceCIN', nullable: true, length: 50 })
  codiceCin!: string | null;

  @Column('nvarchar', { name: 'checkDigitCIN', nullable: true, length: 50 })
  checkDigitCin!: string | null;

  @Column('nvarchar', { name: 'rifBancaEstero', nullable: true, length: 50 })
  rifBancaEstero!: string | null;

  @Column('nvarchar', { name: 'contoCorrente', nullable: true, length: 50 })
  contoCorrente!: string | null;

  @Column('nvarchar', { name: 'codiceBIC', nullable: true, length: 50 })
  codiceBic!: string | null;

  @Column('nvarchar', { name: 'codiceIBAN', nullable: true, length: 50 })
  codiceIban!: string | null;

  @Column('nvarchar', { name: 'codiceABI', nullable: true, length: 50 })
  codiceAbi!: string | null;

  @Column('nvarchar', { name: 'codiceCAB', nullable: true, length: 10 })
  codiceCab!: string | null;

  @Column('nvarchar', { name: 'dataDecesso', nullable: true, length: 10 })
  dataDecesso!: string | null;

  @Column('int', { name: 'modalitaSuddivisioneContributi', nullable: true })
  modalitaSuddivisioneContributi!: number | null;

  @Column('nvarchar', { name: 'dataEsclusione', nullable: true, length: 10 })
  dataEsclusione!: string | null;

  @Column('bigint', { name: 'codiceMotivoEsclusione', nullable: true })
  codiceMotivoEsclusione!: string | null;

  @Column('ntext', { name: 'noteEsclusione', nullable: true })
  noteEsclusione!: string | null;

  @Column('nvarchar', { name: 'usernameWEB', nullable: true, length: 80 })
  usernameWeb!: string | null;

  @Column('nvarchar', { name: 'passwordWEB', nullable: true, length: 80 })
  passwordWeb!: string | null;

  @Column('int', { name: 'consensoNucleoFamiliare', nullable: true })
  consensoNucleoFamiliare!: number | null;

  @Column('int', { name: 'webAccessoDisabilitato', nullable: true })
  webAccessoDisabilitato!: number | null;

  @Column('int', { name: 'webModificaDati', nullable: true })
  webModificaDati!: number | null;

  @Column('int', { name: 'webInfo', nullable: true })
  webInfo!: number | null;

  @Column('int', { name: 'webStrutture', nullable: true })
  webStrutture!: number | null;

  @Column('int', { name: 'webPratiche', nullable: true })
  webPratiche!: number | null;

  @Column('int', { name: 'webCertificazione', nullable: true })
  webCertificazione!: number | null;

  @Column('int', { name: 'webRimborsiBase', nullable: true })
  webRimborsiBase!: number | null;

  @Column('int', { name: 'webRimborsiAvanzato', nullable: true })
  webRimborsiAvanzato!: number | null;

  @Column('int', { name: 'webRichiestaPresaCarico', nullable: true })
  webRichiestaPresaCarico!: number | null;

  @Column('int', { name: 'webServizioCup', nullable: true })
  webServizioCup!: number | null;

  @Column('int', { name: 'webEmailUsername', nullable: true })
  webEmailUsername!: number | null;

  @Column('bigint', { name: 'categoria1', nullable: true })
  categoria1!: string | null;

  @Column('bigint', { name: 'categoria2', nullable: true })
  categoria2!: string | null;

  @Column('bigint', { name: 'categoria3', nullable: true })
  categoria3!: string | null;

  @Column('bigint', { name: 'categoria4', nullable: true })
  categoria4!: string | null;

  @Column('bigint', { name: 'categoria5', nullable: true })
  categoria5!: string | null;

  @Column('int', { name: 'socioEsterno', nullable: true })
  socioEsterno!: number | null;

  @Column('bigint', { name: 'codiceMutua', nullable: true })
  codiceMutua!: string | null;

  @Column('nvarchar', {
    name: 'dataInizioValidita',
    nullable: true,
    length: 10,
  })
  dataInizioValidita!: string | null;

  @Column('nvarchar', { name: 'dataFineValidita', nullable: true, length: 10 })
  dataFineValidita!: string | null;

  @Column('bigint', { name: 'idAssiBase', nullable: true })
  idAssiBase!: string | null;

  @Column('nvarchar', {
    name: 'protezioniAssiBase',
    nullable: true,
    length: 80,
  })
  protezioniAssiBase!: string | null;

  @Column('nvarchar', { name: 'gruppoAssiBase', nullable: true, length: 80 })
  gruppoAssiBase!: string | null;

  @Column('ntext', { name: 'noteAnagrafica', nullable: true })
  noteAnagrafica!: string | null;

  @Column('bigint', { name: 'tipoSocio', nullable: true })
  tipoSocio!: string | null;

  @Column('int', { name: 'stampatoLibroSoci', default: () => '(0)' })
  stampatoLibroSoci!: number;

  @Column('nvarchar', {
    name: 'dataStampaLibroSoci',
    nullable: true,
    length: 10,
  })
  dataStampaLibroSoci!: string | null;

  @Column('int', { name: 'codiceModalitaPagamentoRimborsi', nullable: true })
  codiceModalitaPagamentoRimborsi!: number | null;

  @Column('int', { name: 'codiceModalitaVersamentoContributi', nullable: true })
  codiceModalitaVersamentoContributi!: number | null;

  @Column('nvarchar', { name: 'dataAssunzione', nullable: true, length: 10 })
  dataAssunzione!: string | null;

  @Column('bigint', { name: 'codiceMotivoRecesso', nullable: true })
  codiceMotivoRecesso!: string | null;

  @Column('int', { name: 'codiceCanaleComunicazione', nullable: true })
  codiceCanaleComunicazione!: number | null;

  @Column('nvarchar', { name: 'dataRegistrazione', nullable: true, length: 10 })
  dataRegistrazione!: string | null;

  @Column('ntext', { name: 'noteAnamnesi', nullable: true })
  noteAnamnesi!: string | null;

  @Column('bigint', {
    name: 'codiceModalitacessazioneContributiInfrannuale',
    nullable: true,
  })
  codiceModalitacessazioneContributiInfrannuale!: string | null;

  @Column('int', {
    name: 'forzaCodiceModalitacessazioneContributiInfrannuale',
    nullable: true,
  })
  forzaCodiceModalitacessazioneContributiInfrannuale!: number | null;

  @Column('nvarchar', {
    name: 'matricolaAziendale',
    nullable: true,
    length: 80,
  })
  matricolaAziendale!: string | null;

  @Column('int', { name: 'coniugeCarico', nullable: true })
  coniugeCarico!: number | null;

  @Column('ntext', { name: 'noteProtezioni', nullable: true })
  noteProtezioni!: string | null;

  @Column('bigint', { name: 'idNucleo', nullable: true })
  idNucleo!: string | null;

  @Column('bigint', { name: 'idSocio', nullable: true })
  idSocio!: string | null;

  @Column('bigint', { name: 'idLibroSoci', nullable: true })
  idLibroSoci!: string | null;

  @Column('bigint', { name: 'idPersona', nullable: true })
  idPersona!: string | null;

  @Column('bigint', { name: 'codicePromoter', nullable: true })
  codicePromoter!: string | null;

  @Column('bigint', { name: 'originePromoter', nullable: true })
  originePromoter!: string | null;

  @Column('bigint', { name: 'livelloFamiliareAnagrafica', nullable: true })
  livelloFamiliareAnagrafica!: string | null;

  @Column('bigint', { name: 'codiceCapoFamigliaAnagrafica', nullable: true })
  codiceCapoFamigliaAnagrafica!: string | null;

  @Column('int', { name: 'codiceModalitaVersamentoRID', nullable: true })
  codiceModalitaVersamentoRid!: number | null;

  @Column('nvarchar', {
    name: 'dataPossibileAmmissione',
    nullable: true,
    length: 10,
  })
  dataPossibileAmmissione!: string | null;

  @Column('nvarchar', { name: 'banca', nullable: true, length: 255 })
  banca!: string | null;

  @Column('nvarchar', { name: 'agenziaBanca', nullable: true, length: 255 })
  agenziaBanca!: string | null;

  @Column('nvarchar', { name: 'intestazioneCC', nullable: true, length: 255 })
  intestazioneCc!: string | null;

  @Column('nvarchar', {
    name: 'dataRicezioneRichiestaRecesso',
    nullable: true,
    length: 10,
  })
  dataRicezioneRichiestaRecesso!: string | null;

  @Column('nvarchar', { name: 'dataUscitaNucleo', nullable: true, length: 10 })
  dataUscitaNucleo!: string | null;

  @Column('int', { name: 'datiBancariDaAggiornare', nullable: true })
  datiBancariDaAggiornare!: number | null;

  @Column('nvarchar', { name: 'telefono2', nullable: true, length: 80 })
  telefono2!: string | null;

  @Column('nvarchar', {
    name: 'dataModificaIban',
    nullable: true,
    length: 10,
    default: () => "''",
  })
  dataModificaIban!: string | null;

  @Column('int', {
    name: 'richiestoIBAN',
    nullable: true,
    default: () => '(0)',
  })
  richiestoIban!: number | null;

  @Column('nvarchar', {
    name: 'dataRichiestaIBAN',
    nullable: true,
    length: 10,
    default: () => "''",
  })
  dataRichiestaIban!: string | null;

  @Column('int', { name: 'comunicazioniViaEmail', nullable: true })
  comunicazioniViaEmail!: number | null;

  @Column('int', { name: 'esitoUltimaValidazione', nullable: true })
  esitoUltimaValidazione!: number | null;

  @Column('nvarchar', {
    name: 'dataOraUltimaValidazione',
    nullable: true,
    length: 50,
  })
  dataOraUltimaValidazione!: string | null;

  @Column('ntext', { name: 'noteUltimaValidazione', nullable: true })
  noteUltimaValidazione!: string | null;

  @Column('int', { name: 'stampareLibroSoci', default: () => '(0)' })
  stampareLibroSoci!: number;

  @Column('nvarchar', {
    name: 'dataStampaCessazioneLibroSoci',
    nullable: true,
    length: 10,
    default: () => "'9998-12-31'",
  })
  dataStampaCessazioneLibroSoci!: string | null;

  @Column('int', {
    name: 'stampataCessazioneLibroSoci',
    nullable: true,
    default: () => '(0)',
  })
  stampataCessazioneLibroSoci!: number | null;

  @Column('int', { name: 'adesioneWeb', default: () => '(0)' })
  adesioneWeb!: number;

  @Column('int', { name: 'preeesistenzaContratto', default: () => '(0)' })
  preeesistenzaContratto!: number;

  @Column('int', { name: 'preeesistenzaInclusa', default: () => '(0)' })
  preeesistenzaInclusa!: number;

  @Column('nvarchar', { name: 'IBANRid', length: 50, default: () => "''" })
  ibanRid!: string;

  @Column('nvarchar', {
    name: 'intestatarioContoRid',
    length: 255,
    default: () => "''",
  })
  intestatarioContoRid!: string;

  @Column('nvarchar', {
    name: 'dataMandato',
    length: 10,
    default: () => "'9998-12-31'",
  })
  dataMandato!: string;

  @Column('nvarchar', { name: 'idMandato', length: 10, default: () => "''" })
  idMandato!: string;

  @Column('nvarchar', { name: 'codiceSWIFT', length: 80, default: () => "''" })
  codiceSwift!: string;

  @Column('decimal', {
    name: 'percentualeFamiliareACarico',
    precision: 18,
    scale: 2,
    default: () => '(0)',
  })
  percentualeFamiliareACarico!: number;

  @Column('int', { name: 'familiareMultiplo', default: () => '(0)' })
  familiareMultiplo!: number;

  @Column('nvarchar', {
    name: 'origineAggiornamento',
    length: 20,
    default: () => "''",
  })
  origineAggiornamento!: string;

  @Column('int', { name: 'consensoNewsletter', default: () => '(0)' })
  consensoNewsletter!: number;

  @Column('int', {
    name: 'flagRichiestaVariazioneAnagrafica',
    default: () => '(0)',
  })
  flagRichiestaVariazioneAnagrafica!: number;

  @Column('int', { name: 'flagPresenzaMorositaPrestiti', default: () => '(0)' })
  flagPresenzaMorositaPrestiti!: number;

  @Column('int', { name: 'flagBloccoAmministrativo', default: () => '(0)' })
  flagBloccoAmministrativo!: number;

  @Column('int', { name: 'codiceTitoloStudio', default: () => '(0)' })
  codiceTitoloStudio!: number;

  @Column('varchar', {
    name: 'codiceLuogoDomicilio',
    nullable: true,
    length: 5,
  })
  codiceLuogoDomicilio!: string | null;

  @Column('varchar', { name: 'codiceLuogoNascita', nullable: true, length: 5 })
  codiceLuogoNascita!: string | null;

  @Column('varchar', {
    name: 'codiceLuogoResidenza',
    nullable: true,
    length: 5,
  })
  codiceLuogoResidenza!: string | null;

  @Column('nvarchar', { name: 'domicilioFrazione', nullable: true, length: 80 })
  domicilioFrazione!: string | null;

  @Column('nvarchar', { name: 'nascitaFrazione', nullable: true, length: 80 })
  nascitaFrazione!: string | null;

  @Column('nvarchar', { name: 'residenzaFrazione', nullable: true, length: 80 })
  residenzaFrazione!: string | null;

  @Column('varchar', { name: 'codicePartner', nullable: true, length: 255 })
  codicePartner!: string | null;

  @Column('varchar', {
    name: 'documentoIdentitaCodice',
    nullable: true,
    length: 100,
  })
  documentoIdentitaCodice!: string | null;

  @Column('varchar', {
    name: 'documentoIdentitaDataEmissione',
    nullable: true,
    length: 10,
  })
  documentoIdentitaDataEmissione!: string | null;

  @Column('varchar', {
    name: 'documentoIdentitaDataScadenza',
    nullable: true,
    length: 10,
  })
  documentoIdentitaDataScadenza!: string | null;

  @Column('varchar', {
    name: 'documentoIdentitaEnteRilascio',
    nullable: true,
    length: 100,
  })
  documentoIdentitaEnteRilascio!: string | null;

  @Column('varchar', {
    name: 'documentoIdentitaComuneRilascio',
    nullable: true,
    length: 5,
  })
  documentoIdentitaCodiceLuogoComuneRilascio!: string | null;

  @ManyToOne(() => SocioEntity, (socioEntity) => socioEntity.familiari)
  @JoinColumn([{ name: 'codiceCapofamiglia', referencedColumnName: 'codiceSocio' }])
  capofamiglia!: SocioEntity;

  @OneToMany(() => SocioEntity, (socioEntity) => socioEntity.capofamiglia)
  familiari!: SocioEntity[];

  @ManyToOne(() => GruppoEntity)
  @JoinColumn([{ name: 'codiceGruppo', referencedColumnName: 'codiceGruppo' }])
  gruppo!: GruppoEntity;

  @ManyToOne(() => ApiLuoghiEntity)
  @JoinColumn([{ name: 'codiceLuogoNascita', referencedColumnName: 'codice' }])
  luogoNascita!: ApiLuoghiEntity;

  @ManyToOne(() => ApiLuoghiEntity)
  @JoinColumn([{ name: 'codiceLuogoResidenza', referencedColumnName: 'codice' }])
  luogoResidenza!: ApiLuoghiEntity;

  @ManyToOne(() => ApiLuoghiEntity)
  @JoinColumn([{ name: 'codiceLuogoDomicilio', referencedColumnName: 'codice' }])
  luogoDomicilio!: ApiLuoghiEntity;

  @ManyToOne(() => ApiLuoghiEntity)
  @JoinColumn([{ name: 'documentoIdentitaComuneRilascio', referencedColumnName: 'codice' }])
  documentoIdentitaComuneRilascio!: ApiLuoghiEntity;

  @OneToMany(() => SocioContrattoEntity, (socioContrattoEntity) => socioContrattoEntity.socio)
  socioContratto!: SocioContrattoEntity[];

  @OneToMany(() => SocioFormeAssistenzaEntity, (socioFormeAssistenzaEntity) => socioFormeAssistenzaEntity.socio)
  socioFormeAssistenzas!: SocioFormeAssistenzaEntity[];

  constructor(init?: Partial<SocioEntity>) {
    Object.assign(this, init);
  }
}
