import { Column, Entity, Index } from 'typeorm';

@Index('PK_sportelli', ['codiceSportello'], { unique: true })
@Entity('sportelli')
export class SportelliEntity {
  @Column('nvarchar', { primary: true, name: 'codiceSportello', length: 255 })
  codiceSportello!: string;

  @Column('nvarchar', { name: 'denominazione', length: 255 })
  denominazione!: string;

  @Column('nvarchar', { name: 'email', length: 255 })
  email!: string;

  @Column('nvarchar', { name: 'password', length: 255 })
  password!: string;

  @Column('nvarchar', { name: 'indirizzo', length: 200, default: () => "''" })
  indirizzo!: string;

  @Column('nvarchar', { name: 'citta', length: 200, default: () => "''" })
  citta!: string;

  @Column('nvarchar', { name: 'provincia', length: 2, default: () => "''" })
  provincia!: string;

  constructor(init?: Partial<SportelliEntity>) {
    Object.assign(this, init);
  }
}
