import coerceRecordTypes from '../config/utils/coerce-record-types';
import { registerAs } from '@nestjs/config';
import { z } from 'zod';

export const enumifySchema = z.object({
  shouldUpdateEnumFromDbOnStartup: z.boolean().default(true),
});
export type EnumifyConfig = z.infer<typeof enumifySchema>;

export const enumifyConfig = registerAs('enumify', () => {
  const env = coerceRecordTypes(process.env);

  const config: EnumifyConfig = enumifySchema.strict().parse({
    shouldUpdateEnumFromDbOnStartup: env['ENUM_UPDATE_FROM_DB_ON_START'],
  });
  return config;
});
