import coerceRecordTypes from '../config/utils/coerce-record-types';
import { registerAs } from '@nestjs/config';
import { z } from 'zod';

export const keyvSchema = z.object({
  redis: z.string(),
});
export type KeyvConfig = z.infer<typeof keyvSchema>;

export const keyvConfig = registerAs('keyv', () => {
  const env = coerceRecordTypes(process.env);

  const config: KeyvConfig = keyvSchema.strict().parse({
    redis: env['REDIS_CONNECTION_STRING'],
  });
  return config;
});
