import { Global, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { ApiClientEntity, ApiClientInvocazioniEntity } from '../../database/connections/ebitemp-api';
import { EBITEMP_API_DATASOURCE } from '../../database/connections/ebitemp-api/database.constants';
import { KeyvModule } from '../../keyv/keyv.module';
import { ClientsService } from './clients.service';

@Global()
@Module({
  imports: [
    KeyvModule,
    TypeOrmModule.forFeature([ApiClientEntity, ApiClientInvocazioniEntity], EBITEMP_API_DATASOURCE),
  ],
  providers: [ClientsService],
  exports: [ClientsService],
})
export class ClientsModule {}
