import { Global, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { ApiEndpointEntity, ApiEndpointInvocazioniEntity } from '../../database/connections/ebitemp-api';
import { EBITEMP_API_DATASOURCE } from '../../database/connections/ebitemp-api/database.constants';
import { KeyvModule } from '../../keyv/keyv.module';
import { EndpointsService } from './endpoints.service';

@Global()
@Module({
  imports: [
    KeyvModule,
    TypeOrmModule.forFeature([ApiEndpointEntity, ApiEndpointInvocazioniEntity], EBITEMP_API_DATASOURCE),
  ],
  providers: [EndpointsService],
  exports: [EndpointsService],
})
export class EndpointsModule {}
