import { Module } from '@nestjs/common';
import { ScheduleModule } from '@nestjs/schedule';
import { TypeOrmModule } from '@nestjs/typeorm';
import { TipiJobsEntity } from '../database/connections/ebitemp-api/entities';
import { SchedulerService } from './schedule.service';
import { EBITEMP_API_DATASOURCE } from '../database/connections/ebitemp-api/database.constants';

@Module({
  imports: [TypeOrmModule.forFeature([TipiJobsEntity], EBITEMP_API_DATASOURCE), ScheduleModule.forRoot()],
  providers: [SchedulerService],
  exports: [],
})
export class AppScheduleModule {}
